summaryrefslogtreecommitdiffstats
path: root/development
diff options
context:
space:
mode:
author Jockey S. Kyd2012-02-12 08:00:30 +0100
committer Niels Horn2012-02-18 12:12:28 +0100
commit8508e290527752f03b93bb6df4be8058feef9094 (patch)
treebfc8290d74b99da53836a58b9338ece964743f54 /development
parent468f62393275fa1f23951ba10790fe89be554a70 (diff)
downloadslackbuilds-8508e290527752f03b93bb6df4be8058feef9094.tar.gz
development/mlton: Added (MLton Standard ML Compiler)
Signed-off-by: Robby Workman <rworkman@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/mlton/README7
-rw-r--r--development/mlton/mlton.SlackBuild91
-rw-r--r--development/mlton/mlton.info14
-rw-r--r--development/mlton/slack-desc19
4 files changed, 131 insertions, 0 deletions
diff --git a/development/mlton/README b/development/mlton/README
new file mode 100644
index 0000000000..df57f0fd72
--- /dev/null
+++ b/development/mlton/README
@@ -0,0 +1,7 @@
+MLton is an open-source, whole-program, optimizing Standard ML compiler. It
+aims to produce fast executables, and to encourage rapid prototyping and
+modular programming by eliminating performance penalties often associated with
+the use of high-level language features.
+
+This is a prebuilt binary package to shorten overwhelmingly long time of local
+compilation.
diff --git a/development/mlton/mlton.SlackBuild b/development/mlton/mlton.SlackBuild
new file mode 100644
index 0000000000..7cf5bbb870
--- /dev/null
+++ b/development/mlton/mlton.SlackBuild
@@ -0,0 +1,91 @@
+#!/bin/sh
+
+# Copyright 2011,2012 Jockey S. Kyd, Shanghai, CHN
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+PRGNAM=mlton
+VERSION=20100608
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$(uname -m) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+case "$ARCH" in
+ i?86) LIBDIRSUFFIX=""
+ TARARCH="x86" ;;
+ x86_64) LIBDIRSUFFIX="64"
+ TARARCH="amd64" ;;
+ *) printf "$ARCH is not supported.\n" 1>&2
+ exit 1 ;;
+esac
+
+# pick the tarball with dynamically linked distribution preferred
+DIST=$PRGNAM-$VERSION-1.$TARARCH-linux
+if [ ! -f $CWD/$DIST.tgz ]; then
+ # no dynamically linked version, hence pick static linked one
+ DIST=$PRGNAM-$VERSION-1.$TARARCH-linux.static
+ if [ ! -f $CWD/$DIST.tgz ]; then
+ printf "No tarball found.\n" 1>&2
+ exit 1
+ fi
+fi
+
+set -e
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $PKG
+tar xvf $CWD/$DIST.tgz
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+[ "$LIBDIRSUFFIX" = "64" ] && mv $PKG/usr/lib{,64}
+sed -i "s|^lib=.*$|lib='/usr/lib$LIBDIRSUFFIX/mlton'|" $PKG/usr/bin/mlton
+
+find $PKG -print0 | xargs -0 file \
+ | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null \
+ || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+mv $PKG/usr/share/doc/mlton/* $PKG/usr/doc/$PRGNAM-$VERSION/
+rm -rf $PKG/usr/share
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/development/mlton/mlton.info b/development/mlton/mlton.info
new file mode 100644
index 0000000000..c1b9dd82ae
--- /dev/null
+++ b/development/mlton/mlton.info
@@ -0,0 +1,14 @@
+PRGNAM="mlton"
+VERSION="20100608"
+HOMEPAGE="http://mlton.org/"
+DOWNLOAD="http://mlton.org/pages/Download/attachments/mlton-20100608-1.x86-linux.tgz \
+ http://mlton.org/pages/Download/attachments/mlton-20100608-1.x86-linux.static.tgz"
+MD5SUM="6c2cd50709b3309b0ec435002fb1e4cf \
+ dc6101f8923b23cd2875a74e353f520e"
+DOWNLOAD_x86_64="http://mlton.org/pages/Download/attachments/mlton-20100608-1.amd64-linux.tgz \
+ http://mlton.org/pages/Download/attachments/mlton-20100608-1.amd64-linux.static.tgz"
+MD5SUM_x86_64="3598a53e45d0806d359203bb36405710 \
+ 546b8941c35a93df4866ef91129e0f35"
+MAINTAINER="Jockey S. Kyd"
+EMAIL="jockey.kyd@gmail.com"
+APPROVED="rworkman"
diff --git a/development/mlton/slack-desc b/development/mlton/slack-desc
new file mode 100644
index 0000000000..f7aca3c197
--- /dev/null
+++ b/development/mlton/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+mlton: mlton (MLton Standard ML Compiler)
+mlton:
+mlton: MLton is an open-source, whole-program, optimizing Standard ML
+mlton: compiler. It aims to produce fast executables, and to encourage rapid
+mlton: prototyping and modular programming by eliminating performance
+mlton: penalties often associated with the use of high-level language
+mlton: features.
+mlton:
+mlton: http://mlton.org/
+mlton:
+mlton: